#!/usr/local/bin/perl

#######################################################
#
#	eTicket, Open Source Support Ticket System
#	http://eticket.sourceforge.net/
#
#	Released under the GNU General Public License
#
#######################################################
#
#	Setup automail.pl Email Gateway for piping/aliases
#
#	Configure Sendmail and MySQL settings.
#
#######################################################

%config = (mailprog => '/usr/lib/sendmail',
		   db_type => 'mysql',
		   db_host => 'localhost',
		   db_name => '',
		   db_user => '',
		   db_pass => '');

# Note: This should work without any editing, just run the installer, but if it doesn't, edit the settings appropreately

#flood protection mod - you can change the number here, its the max num of messages per min sent by 1 email.
$flood_msg_rate = 10;

#antispam mod - the over-ride or exception word (NOT PHRASE, no spaces), this word must be in the body text to over-ride the ban list
$ANTISPAM_MAGICWORD = 'ANTI_SPAM_MAGICWORD';
#antispam mod - subject for spam rejection notice
$ANTISPAM_SUBJECT = 'Ticked Rejected: Mail detected as SPAM';
#antispam mod - rejection message (don't take out {MAGICWORD} from this text, it gets replaced later automatically)
$ANTISPAM_MSG = "Your email was detected as spam and has been rejected. If your email was not spam, please re-send your email, including the word '{MAGICWORD}' in the body of the email.";
#antispam mod - email to send the rejection message from (you would use a non-existing email address at your domain)
$ANTISPAM_EMAIL = 'donotreply@example.com';

#SpamAssassin mod - set this to 1 to enable this mod
$spamassassin_enable = 1;
#SpamAssassin mod - this is the word you put in your subjects to idenify spam, add it to your helpdesk banlist
$spamword = '[SPAM]';

#language mod - Default subject if there's no subject entered
$no_subject = '[No Subject]';
#language mod - "|" seperated terms that mean "Re" (as in Reply/Respond/Regarding/Re:) add your language (Do not add the :)
$subject_re = 'Re|Antw';

#language charset mod - added for outgoing mail
$charset='ISO-8859-1';

#the pre-signature, the string that appears before each signature is attached
$presig="\r\n--\n";

#######################################################
#	No further editing is required...
#######################################################

#functions area...
use MIME::Base64;

sub is_valid {
    $ticket = $_[0];

    $sth = $dbh->prepare("SELECT * FROM tickets WHERE ID=$ticket");
    $sth->execute();

    $hash = $sth->fetchrow_hashref;
    $sth->finish();

    return $hash->{ID};
}

sub sendmail {
    ($to, $from, $subj, $msgbody) = @_;
    open(MAIL, "|$config{'mailprog'} -t");
		print MAIL "Content-type: text/plain; charset=$charset\n";
    print MAIL "To: $to\n";
    print MAIL "From: $from\n";
    print MAIL "Subject: $subj\n";
    print MAIL "Precedence: bulk\n\n";
    print MAIL "$msgbody\n";
    close(MAIL);
}

sub keyword {
    $subject = $eml_subj;
    $datetime = $header{'Date'};
    $_[0] =~ s/%([_|a-zA-Z][a-zA-Z|\d|_]*)/${$1}/gi;
}

sub timeconvert {
	$mysql_timestamp = $_[0];
    $x=mysql_fetch_array(mysql_query("SELECT UNIX_TIMESTAMP('$mysql_timestamp') AS timestamp"));
    $x[timestamp];
    return $x[timestamp];
}

sub trim($)
{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}

#MIME language mod functions - START
# I included the following functions so you don't need the following modules in perl
# use MIME::Words qw(:all);   # RD2004-01-16
# use MIME::QuotedPrint;      # RD2004-01-16

### The package version, both in 1.23 style *and* usable by MakeMaker:
$VERSION = substr q$Revision: 6.107 $, 10;

### Nonprintables (controls + x7F + 8bit):
my $NONPRINT = "\\x00-\\x1F\\x7F-\\xFF"; 

# _decode_Q STRING
#     Private: used by _decode_header() to decode "Q" encoding, which is
#     almost, but not exactly, quoted-printable.  :-P
sub _decode_Q {
    my $str = shift;
    $str =~ s/_/\x20/g;                                # RFC-1522, Q rule 2
    $str =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge;  # RFC-1522, Q rule 1
    $str;
}

# _encode_Q STRING
#     Private: used by _encode_header() to decode "Q" encoding, which is
#     almost, but not exactly, quoted-printable.  :-P
sub _encode_Q {
    my $str = shift;
    $str =~ s{([_\?\=$NONPRINT])}{sprintf("=%02X", ord($1))}eog;
    $str;
}

# _decode_B STRING
#     Private: used by _decode_header() to decode "B" encoding.
sub _decode_B {
    my $str = shift;
    decode_base64($str);
}

# _encode_B STRING
#     Private: used by _decode_header() to decode "B" encoding.
sub _encode_B {
    my $str = shift;
    encode_base64($str, '');
}

# decode STRING
sub decode_mimewords {
    my $encstr = shift;
    my %params = @_;
    my @tokens;
    $@ = '';           ### error-return

    ### Collapse boundaries between adjacent encoded words:
    $encstr =~ s{(\?\=)\r?\n[ \t](\=\?)}{$1$2}gs;
    pos($encstr) = 0;
    ### print STDOUT "ENC = [", $encstr, "]\n";

    ### Decode:
    my ($charset, $encoding, $enc, $dec);
    while (1) {
	last if (pos($encstr) >= length($encstr));
	my $pos = pos($encstr);               ### save it

	### Case 1: are we looking at "=?..?..?="?
	if ($encstr =~    m{\G             # from where we left off..
			    =\?([^?]*)     # "=?" + charset +
			     \?([bq])      #  "?" + encoding +
			     \?([^?]+)     #  "?" + data maybe with spcs +
			     \?=           #  "?="
			    }xgi) {
	    ($charset, $encoding, $enc) = ($1, lc($2), $3);
	    $dec = (($encoding eq 'q') ? _decode_Q($enc) : _decode_B($enc));
	    push @tokens, [$dec, $charset];
	    next;
	}

	### Case 2: are we looking at a bad "=?..." prefix? 
	### We need this to detect problems for case 3, which stops at "=?":
	pos($encstr) = $pos;               # reset the pointer.
	if ($encstr =~ m{\G=\?}xg) {
	    $@ .= qq|unterminated "=?..?..?=" in "$encstr" (pos $pos)\n|;
	    push @tokens, ['=?'];
	    next;
	}

	### Case 3: are we looking at ordinary text?
	pos($encstr) = $pos;               # reset the pointer.
	if ($encstr =~ m{\G                # from where we left off...
			 ([\x00-\xFF]*?    #   shortest possible string,
			  \n*)             #   followed by 0 or more NLs,
		         (?=(\Z|=\?))      # terminated by "=?" or EOS
			}xg) {
	    length($1) or die "MIME::Words: internal logic err: empty token\n";
	    push @tokens, [$1];
	    next;
	}

	### Case 4: bug!
	die "MIME::Words: unexpected case:\n($encstr) pos $pos\n\t".
	    "Please alert developer.\n";
    }
    return (wantarray ? @tokens : join('',map {$_->[0]} @tokens));
}

sub decode_qp ($)
{
    my $res = shift;
    $res =~ s/\r\n/\n/g;            # normalize newlines
    $res =~ s/[ \t]+\n/\n/g;        # rule #3 (trailing space must be deleted)
    $res =~ s/=\n//g;               # rule #5 (soft line breaks)
    if (ord('A') == 193) { # EBCDIC style machine
        if (ord('[') == 173) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('cp1047',Encode::decode('iso-8859-1',pack("C", hex($1))))/ge;
        }
        elsif (ord('[') == 187) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('posix-bc',Encode::decode('iso-8859-1',pack("C", hex($1))))/ge;
        }
        elsif (ord('[') == 186) {
            $res =~ s/=([\da-fA-F]{2})/Encode::encode('cp37',Encode::decode('iso-8859-1',pack("C", hex($1))))/ge;
        }
    }
    else { # ASCII style machine
        $res =~ s/=([\da-fA-F]{2})/pack("C", hex($1))/ge;
    }
    $res;
}
#MIME language mod functions - END


# rest of code ...

#database connection
use DBI;
$dbh = DBI->connect("DBI:$config{'db_type'}:$config{'db_name'}:$config{'db_host'}", $config{'db_user'}, $config{'db_pass'});

#database configuration
$sth = $dbh->prepare("SELECT * FROM ticket_config");
$sth->execute();
$myconfig = $sth->fetchrow_hashref;

$url = $myconfig->{root_url};

#email message
while (<STDIN>) {
    push @message, $_;
    $eml .= $_;
}

#SpamAssassin start
#Note: to install do: perl -MCPAN -e'install Mail::SpamAssassin'
if ($spamassassin_enable == 1) {

	eval("use Mail::SpamAssassin;");
	if ($@) { die("Failed to load module Mail::SpamAssassin: $@"); }
	else {

	#email size check - if its too big, the script will just exit
	if (length($eml) > $myconfig->{attachment_size} + 1024) { exit(); }

	  use Mail::SpamAssassin;
	  my $spamtest = Mail::SpamAssassin->new();
	  my $mail = $spamtest->parse($eml);
	  my $status = $spamtest->check($mail);

	  if ($status->is_spam()) { $isspam = 1; }
	  else { $isspam = 0; }

	  $eml = $status->rewrite_mail();

	  $status->finish();
	  $mail->finish();

	}
}
#SpamAssassin end

#parse headers
foreach (@message) {
    push @headers, $_;
    last if (/^\s$/ || /^$/);
    if (/boundary=/i) {
        $attachment_info = $_;
        $attachment = 1;
    }
    else { $attachment = 0; }
    $_ =~ s/:\s/:/g;
    if (/:/) {
        @vars = split(':', $_, 2);
        if ($vars[1]) {
            chop($header{$vars[0]} = $vars[1]);
            $previous_header=$vars[0];
        }
    } elsif ($previous_header eq 'Subject') {
        chop($_);        # delete trailing \n
        $_ =~ s/^\s*//g; # delete start spaces
        $header{'Subject'} = $header{'Subject'} . $_;
    }
}

$eml_subj = decode_mimewords($header{'Subject'});
# RD2004-01-16 Fix message subject accents
$eml_subj = decode_qp($eml_subj);
$sent_from = decode_mimewords($header{'From'});
$sent_from =~ s/"//g;
$sent_to = decode_mimewords($header{'To'});
$sent_to =~ s/"//g;

$eml_subj =~ s/\s*($subject_re):s*//gi if ($eml_subj);;
$eml_subj = $no_subject if (!$eml_subj);
$sent_from =~ s/"/\"/g;
$sent_to =~ s/"/\"/g;

#fix the from email and name
@what = split('<', $sent_from, 2);
$email_from = $what[1];
$email_from =~ s/\>//g;
$email_from =~ s/\'//g;
$email_from = lc($email_from);
$name_from = $what[0];
$name_from =~ s/\s$//;
if (!$name_from) { $name_from = $email_from; }
elsif (!$email_from) { $email_from = $name_from; }

#fix the sent email and name
@what = split('<', $sent_to, 2);
$email_to = $what[1];
$email_to =~ s/\>//g;
$email_to =~ s/\'//g;
$email_to = lc($email_to);
$name_to = $what[0];
$name_to =~ s/\s$//;
if (!$name_to) { $name_to = $email_to; }
elsif (!$email_to) { $email_to = $name_to; }

#SpamAssassin Subject Mod START
if ($eml_subj !~ /^\Q$spamword\E/) { $eml_subj = $spamword." ".$eml_subj if ($isspam == 1); }
#SpamAssassin Subject Mod END

@ticket = split('\[#', $eml_subj, 2);
chop($ticket[1]);
$ticket = int($ticket[1]);

$eml_subj =~ s/\s*\[#[0-9]*\]\s*//gi if ($eml_subj);

exit 0 if $header{'Precedence'} =~ /(bulk|list|junk)/i;

#is address banned? - this does email addresses now instead, fix this in the antispam addon too
$sth = $dbh->prepare("SELECT * FROM ticket_banlist WHERE value LIKE '%@%'");
$sth->execute();
while ($ban = $sth->fetchrow_hashref) {
    $banlist = $ban->{value};
    if ($email_from =~ /$banlist/i) { exit; }
}

#format email priority to ticket priority.
$pri = $header{'X-Priority'};
if ($pri == 1 or $pri == 2) { $pri = 3; }
elsif ($pri == 3) { $pri = 2; }
elsif ($pri == 4 or $pri == 5) { $pri = 1; }
else { $pri = 2; }

#attachment info
($i, $boundary) = split("\"", $attachment_info);

#get filenames and base64 codes for file attachments
if ($boundary) {
    @eml = split($boundary, $eml);
    for ($i = 0; $i <= $#eml; ++$i) {
        if ($eml[$i] =~ /filename/) {
            @lines = split("\n", $eml[$i]);

            $encoding = $eml[$i];
            $encoding =~ s/Content-Transfer-Encoding:\s(.*)\n/$1/i;
            push @encoding, $encoding;

            $feed = 0;
            $code = "";
            foreach (@lines) {
                if ($feed) { $code .= "$_\n"; }
                if ($_ =~ /filename/) {
                    $_ =~ s/.*filename="(.*)"/$1/;
                    push @files, $_;
                    $feed = 1;
                }
            }
            push @codes, $code;
        }
        else { push @bodies, $eml[$i]; }
    }
}
else {
    for ($i = $#headers + 1; $i <= $#message; $i++) { $body .= $message[$i]; }
}

#find body (if multi-part email)
foreach(@bodies) {
    @lines = split("\n", $_);
    foreach (@lines) {
        if (/boundary=/i) { $b = $_; }
    }
    ($i, $boundary) = split("\"", $b);
    if ($boundary) { @ibodies = split($boundary, $_); }
    else { $ibodies[0] = $_; }

    foreach(@ibodies) {
        if ($#bodies == 0) { $type = ".*"; }
        else { $type = "plain"; }
        if (/content-type:\stext\/$type/i) {
            $body = $_;
            @lines = split("\n", $body);
            $body = "";
            $f = -1;
            foreach(@lines) {
                if ($f) { $body .= "$_\n"; }
                if (!$_) { ++$f; }
            }

        }
    }
}

## antispam addon
$sth = $dbh->prepare("SELECT ID FROM tickets WHERE ID = ".$ticket);
$sth->execute();
$antispam_bypass = 0;
if ($ban = $sth->fetchrow_hashref) { $antispam_bypass = 1; }
$sth = $dbh->prepare("SELECT * FROM ticket_banlist WHERE value NOT LIKE '%@%'");
$sth->execute();
$antispam_spambody = $eml_subj . $body;
if (!($antispam_spambody =~ /$ANTISPAM_MAGICWORD/i) && ($antispam_bypass == 0)) {
	while ($ban = $sth->fetchrow_hashref) {
	    $banlist = $ban->{value};
	    $banlist =~ s/\!//g;
	    if ($antispam_spambody =~ /\Q$banlist\E/i) {
	    	$ANTISPAM_MSG =~ s/{MAGICWORD}/$ANTISPAM_MAGICWORD/g;
	    	sendmail($sent_from, $ANTISPAM_EMAIL, $ANTISPAM_SUBJECT, $ANTISPAM_MSG);
		   	exit();
	    }
	}
}
## end antispam

#delete original message
if ($myconfig->{remove_original} && $myconfig->{remove_tag} && index($body, $myconfig->{remove_tag})) {
    $remove_tag = $myconfig->{remove_tag};
    @lines = split(/$remove_tag/i, $body);
    $body = $lines[0];

    @lines = split(/-*[\n|\s|\0]?Original Message[\n|\s|\0]?-*/, $body);
    $body = $lines[0];
}

#get category
$cat = 1;
$sth = $dbh->prepare("SELECT * FROM ticket_categories");
$sth->execute();
while ($row_hash = $sth->fetchrow_hashref) {
    if ($row_hash->{email} =~ /$email_to/i) {
        $email_to = $row_hash->{email};
        $cat = $row_hash->{ID};
        $signature = $row_hash->{signature};
		$category = $row_hash->{name};
    }
}

# RD2004-01-16 Fix message body accents
$body = decode_qp($body);

#strip tags and trim
$body =~ s/<(([^ >]|\n)*)>//g;
$body =~ s/<script[^>]*?>.*?<\/script>//g;
$body =~ s/<[\/!]*?[^<>]*?>//g;
$body =~ s/'/\\'/g;
$body =~ s/^(.*)>/<$1>/i;
$body =~ s/--$//g;
$body =~ s/>$//g;
$body = trim($body);

#add signature/remove tag
if ($signature) { $signature = $presig.$signature; }
if ($myconfig->{remove_original}) { $remove_tag = $myconfig->{remove_tag} . "\n\n"; }

#save email headers
if ($myconfig->{save_headers}) { $eml_headers = trim(decode_qp($eml)); }

#get greenwich mean time
use POSIX;
@gm = gmtime();
$gmtime = POSIX::mktime($gm[0], $gm[1], $gm[2], $gm[3], $gm[4], $gm[5]);

@oldgm = gmtime(time()-75);
$gmoldtime = $oldgm[5] . $oldgm[4] . $oldgm[3] . $oldgm[2] . $oldgm[1] . $oldgm[0];

# flood protection, find all posts made by this email address in the last X minutes
$smoog_email=$email_from;

$smoog_mysqltime = $gmtime - 75;
$smoog_earlieststamp = -1;
$smoog_messagesfound = 0;
$smoog_query = "SELECT * FROM tickets WHERE email='$smoog_email' ORDER BY timestamp ASC";
$smoog_tickets = $dbh->prepare($smoog_query);
$smoog_tickets->execute();

while ($smoog_t = $smoog_tickets->fetchrow_hashref) {
	  $smoog_query = "SELECT UNIX_TIMESTAMP(timestamp) as unitimestamp FROM ticket_messages WHERE ticket='".$smoog_t->{ID}."' AND timestamp > '$gmoldtime'";
      $smoog_messages = $dbh->prepare($smoog_query);
      $smoog_messages->execute();
      while ($m = $smoog_messages->fetchrow_hashref) {
      		if ($smoog_earlieststamp == -1 || $smoog_earlieststamp > $m->{unitimestamp}) {
      			$smoog_earlieststamp = $m->{unitimestamp};
      		} 
			$smoog_messagesfound++;
     }
}

# done figuring out recent message count, now lets check the rate.
$smoog_msgrate = (60 * $smoog_messagesfound) / ($gmtime - $smoog_earlieststamp); 
if (!length($smoog_email) || $smoog_msgrate > $flood_msg_rate) { exit; }

# end flood protection

#add message for ticket if it is valid
if (is_valid($ticket)) {
    $sth = $dbh->prepare("UPDATE tickets SET status = 'open' WHERE ID=$ticket");
    $sth->execute();

		$sth = $dbh->prepare("INSERT INTO ticket_messages (ticket, message, headers, timestamp) VALUES (?, ?, ?, FROM_UNIXTIME(?))");
		$sth->execute($ticket, $body, $eml_headers, $gmtime);

    keyword($myconfig->{message_subj});
    keyword($myconfig->{message_msg});

    if ($myconfig->{message_response}) {
        sendmail($sent_from, $sent_to, $myconfig->{message_subj}, $remove_tag.$myconfig->{message_msg}.$signature);
    }
}
#create new ticket
else {
    do {
        $min = 100000;
        $max = 999999;
        $ticket = int(rand($max - $min + 1)) + $min;
    } while (is_valid($ticket));

    chdir($myconfig->{attachment_dir});

    $sth = $dbh->prepare("SELECT COUNT(*) AS tq FROM tickets WHERE email='$email' AND status='open'");
    $sth->execute();
    $row_hash = $sth->fetchrow_hashref;
    $tq = $row_hash->{tq};

    if ($tq < $myconfig->{ticket_max}) {

        $sth = $dbh->prepare("SELECT UNIX_TIMESTAMP(timestamp) AS timestamp FROM tickets WHERE email='$email' ORDER BY timestamp DESC");
        $sth->execute();
        $row_hash = $sth->fetchrow_hashref;
        $interval = time() - $row_hash->{timestamp};

		$ip=$header{'X-Originating-IP'};
        $ip =~ s/\[(.*)\]/$1/;
		if ($ip == '') { $ip=""; }

        $sth = $dbh->prepare("INSERT INTO tickets (subject, name, email, cat, status, ID, priority, ip, timestamp) VALUES (?, ?, ?, ?, ?, ?, ?, ?, FROM_UNIXTIME(?))") or die $dbh->errstr;
        $sth->execute($eml_subj, $name_from, $email_from, $cat, 'open', $ticket, $pri, $ip, $gmtime) or die $dbh->errstr;

        $sth = $dbh->prepare("INSERT INTO ticket_messages (ticket, message, headers, timestamp) VALUES (?, ?, ?, FROM_UNIXTIME(?))") or die $dbh->errstr;
        $sth->execute($ticket, $body, $eml_headers, $gmtime) or die $dbh->errstr;

        if ($interval >= $myconfig->{min_interval}) {
            keyword($myconfig->{ticket_subj});
						#$email and $message are vars for %vars
						$email = $email_from;
						$message = $body;
            keyword($myconfig->{ticket_msg});
            if ($myconfig->{ticket_response}) {
                sendmail($sent_from, $sent_to, $myconfig->{ticket_subj}, $remove_tag.$myconfig->{ticket_msg}.$signature);
            }
        }
    }
    #if over ticket limit
    else {
        $ticket_max = $myconfig->{ticket_max};

        keyword($myconfig->{limit_subj});
        keyword($myconfig->{limit_msg});
        if ($myconfig->{limit_response}) {
            sendmail($sent_from, $myconfig->{limit_email}, $myconfig->{limit_subj}, $myconfig->{limit_msg}.$signature);
        }
    }
}

if ($ticket) {
	#alert owner
	if ($myconfig->{alert_new}) {
		#fix the keywords from vars
		keyword($myconfig->{alert_subj});
		#below are vars for %vars
		$email = $email_from;
		$name = $name_from;
		$message = $body;
		keyword($myconfig->{alert_msg});
		#send the email
		sendmail($myconfig->{alert_user}, $myconfig->{alert_email}, $myconfig->{alert_subj}, $myconfig->{alert_msg});
	}
}

#upload attachments
if ($myconfig->{accept_attachments} && $myconfig->{attachment_dir}) {
    #use MIME::Base64; #->moved to top
    chdir($myconfig->{attachment_dir});

    $sth = $dbh->prepare("SELECT LAST_INSERT_ID() AS iid");
    $sth->execute();
    $row_hash = $sth->fetchrow_hashref;
    $iid = $row_hash->{iid};

    for ($i = 0; $i <= $#files; ++$i) {
        $id=int(rand(999999-100000+1))+100000;
        $filename=$id."_$files[$i]";
        open(ATTACH, ">$filename");
        binmode(ATTACH);
        $codes[$i] =~ s/Content-Transfer-Encoding:\s(.*)\n//i;

        if ($encoding[$i] =~ /base64/i) { $codes[$i] = decode_base64($codes[$i]); }
        if ($encoding[$i] =~ /7bit/i) { $codes[$i] =~ s/--$//g; $codes[$i] = trim($codes[$i]); }

        if (length($codes[$i]) < $myconfig->{attachment_size}) { print ATTACH $codes[$i]; }
        close(ATTACH);

        $sth = $dbh->prepare("INSERT INTO ticket_attachments (ticket, ref, filename, type) VALUES ($ticket, $iid, '$filename', 'q')");
        $sth->execute();
    }
}

$sth->finish();
$dbh->disconnect();
