<?php

if(!defined('ISINC')) die('serious error');

if (!$_SESSION['user']) { logout($page); } //logout to force login if there's no user
if ($_REQUEST['reset']) { unset($_SESSION['view']); } //reset view settings

/* Filter & Session Data - START */

//Switch view status
if ($_POST['view_open_x']) { $_SESSION['view']['status'] = 'open'; }
elseif ($_POST['view_closed_x']) { $_SESSION['view']['status'] = 'closed'; }
elseif ($_POST['view_answered_x']) { $_SESSION['view']['status'] = 'answered'; }

if (isset($_REQUEST['status'])) $_SESSION['view']['status']=$_REQUEST['status']?$_REQUEST['status']:'';

//the default is to read 'open' tickets
if (!isset($_SESSION['view']['status'])) { //changed both to open as I added last answered back
	if ($_SESSION['user']['type'] == 'admin') $_SESSION['view']['status']='open';
	if ($_SESSION['user']['type'] == 'client') $_SESSION['view']['status']='open';
}

//if an admin submits an email search
if (($_SESSION['user']['type'] == 'admin') && (isset($_REQUEST['email'])) && ($_REQUEST['email'])) { $filter['email']=$_REQUEST['email']; }

//if they are a client (not admin) we must force filter their query
if ($_SESSION['user']['type'] == 'client') { $filter['email']=$_SESSION['user']['id']; }

//how should we order?
if ((!$_SESSION['view']['sort']) || (!$_SESSION['view']['way']) || !$_REQUEST['s']) {
	switch ($_SESSION['view']['status']) {
		case open:
			$_SESSION['view']['sort']='timestamp';
			$_SESSION['view']['way']='ASC';
		break;
		case answered:
			$_SESSION['view']['sort']='timestamp';
			$_SESSION['view']['way']='DESC';
		break;
		case closed:
			$_SESSION['view']['sort']='timestamp';
			$_SESSION['view']['way']='DESC';
		break;
	}
}

if ($_REQUEST['s']) {
	if ($_REQUEST['sort']) { $_SESSION['view']['sort']=$_REQUEST['sort']; }
	if ($_REQUEST['way']) { $_SESSION['view']['way']=$_REQUEST['way']; }
}

if (($_SESSION['view']['sort']) && ($_SESSION['view']['way'])) { $_SESSION['view']['orderby']='tickets.'.$_SESSION['view']['sort'].' '.$_SESSION['view']['way']; }

//filter by catagory
if (isset($_REQUEST['cat'])) $_SESSION['view']['cat']=get_magic_quotes_gpc()?$_REQUEST['cat']:addslashes($_REQUEST['cat']);

//set tickets per page
$_SESSION['view']['per']=$_REQUEST['per']?$_REQUEST['per']:$config['tickets_per_page'];

//set page number
$_SESSION['view']['p']=$_REQUEST['p']?$_REQUEST['p']:1;

/* Filter & Session Data - END */

//correct dates
if (isset($_REQUEST['date_from'])) { 
	$_REQUEST['date_from']=date('Y-m-d', strtotime($_REQUEST['date_from']));
	$_SESSION['view']['date_from']=$_REQUEST['date_from'];
}
if (isset($_REQUEST['date_to'])) { 
	$_REQUEST['date_to']=date('Y-m-d', strtotime($_REQUEST['date_to']));
	$_SESSION['view']['date_to']=$_REQUEST['date_to'];
}

/* set vars */
if ((isset($_REQUEST['text'])) && ($_REQUEST['text'])) $text=addslashes($_REQUEST['text']);
if (isset($_REQUEST['s'])) { $s=$_REQUEST['s']; }

$orderby=$_SESSION['view']['orderby'];
$per=$_SESSION['view']['per'];
$p=$_SESSION['view']['p'];
$status=$_SESSION['view']['status'];
$date_from=$_SESSION['view']['date_from'];
$date_to=$_SESSION['view']['date_to'];

/*Table Details*/

if ($_REQUEST['s']) {	$newway=($_SESSION['view']['way'] == 'ASC')?'DESC':'ASC'; }
else { $newway=$_SESSION['view']['way']; }

$table_header = '
	  <tr>
	    <td width="22">&nbsp;</td>
	    <td width="50" class="TableHeaderText" title="'.LANG_TIP_TICKET.'"><a href="?s=advanced&sort=ID&way='.$newway.'">'.LANG_TICKET.'</a></td>
	    <td width="70" class="TableHeaderText" title="'.LANG_TIP_DATE.'"><a href="?s=advanced&sort=timestamp&way='.$newway.'">'.LANG_DATE.'</a></td>
	    <td width="263" class="TableHeaderText" title="'.LANG_TIP_SUBJECT.'"><a href="?s=advanced&sort=subject&way='.$newway.'">'.LANG_SUBJECT.'</a></td>
	    <td width="100" class="TableHeaderText" title="'.LANG_TIP_CAT.'"><a href="?s=advanced&sort=cat&way='.$newway.'">'.LANG_CAT.'</a></td>
	    <td width="50" class="TableHeaderText" title="'.LANG_TIP_PRIORITY.'"><a href="?s=advanced&sort=priority&way='.$newway.'">'.LANG_PRIORITY.'</a></td>
	    <td width="125" class="TableHeaderText" title="'.LANG_TIP_FROM.'"><a href="?s=advanced&sort=name&way='.$newway.'">'.LANG_FROM.'</a></td>
	    <td width="20" class="TableHeaderText" title="'.LANG_TIP_UM.'"><a href="?s=advanced&sort=unanswered&way='.$newway.'">'.LANG_UM.'</a></td>
	  </tr>';

$table_content = '
		  <tr class="{class}" onmouseover="this.className=\'mainTableOn\';" onmouseout="this.className=\'{class}\';">
		   <td align="center">{checkbox}</td>
		   <td align="center"><a href="{page}?a=view&amp;id={id}">{id}</a></td>
		   <td align="center">{short_time}</td>
		   <td><a href="{page}?a=view&amp;id={id}">{subject}</a></td>
		   <td>{cat_name}</td>
		   <td align="center" {pri_style}>{pri_text}</td>
		   <td><a onClick="document.forms[0].email.value=\'{email}\';" title="{email}">{name}</a></td>
		   <td>{unanswered}</td>
			</tr>';

/* Create Query Start */

// which base sql query
if ($text) { //if theres text to search we need more tables!
	$query="SELECT DISTINCT tickets.ID AS ID, tickets.status, tickets.timestamp as timestamp, tickets.cat AS cat, tickets.subject AS subject, priority, tickets.name AS name FROM ( ( tickets LEFT JOIN ticket_messages ON ticket_messages.ticket = tickets.ID ) LEFT JOIN ticket_answers ON ticket_answers.reference = ticket_messages.ID )";
}
else { $query="SELECT * FROM tickets"; }

//set filters for the where statement
$filter['status']=$_SESSION['view']['status'];
if ($_SESSION['view']['cat']) $filter['cat']=$_SESSION['view']['cat'];

//implode the $filter array together into the WHERE
if (is_array($filter)) {
	foreach ($filter as $key => $value) {
		if ($key == 'status' && $value == 'answered') { $value='open'; } //work around
		if (isset($where)) { $where.=' AND '; }
		else { $where=''; }
		$where.="tickets.$key = '".$value."'";
	}
}

if ($_REQUEST['use_dates']) {
	//date('Y-m-d H:i:s',$date);
		if (isset($where)) { $where.=' AND '; }
		else { $where=''; }
		$where.="tickets.timestamp BETWEEN '$date_from' AND '$date_to'";
}

if ($text) {
	if (isset($where)) { $where.=' AND '; }
	else { $where=''; }
	$where.="(
    ticket_messages.message LIKE '%$text%' OR
    ticket_answers.message LIKE '%$text%' OR
    tickets.subject LIKE '%$text%'
    )";
}

//add the where to the rest of the query
if ((isset($where)) && ($where)) { $query.=" WHERE $where"; }

//add the ordering at the end
if ($orderby) $query.=" ORDER BY ".$orderby;

/* Create Query End */

	//if ($_SESSION['user']['type'] == 'admin') { echo '<!--'; print_r($login); echo '-->'; } //debugging

	//get a list of tickets as per query
	if ($sql=mysql_query($query)) {
		while ($result=mysql_fetch_array($sql)) {
			$result['unanswered']=get_un_tickets($result['ID']);
			if (!$result['unanswered'] && $result['status'] !== 'closed') { $result['status'] = 'answered'; }
			if ($_SESSION['user']['type'] == 'client' || (@in_array($result['cat'], $login['cat_access']) || $login['cat_access'][0] == 'all')) { //filter by permissions
					//code for last X answered
					/*<h2><?=LANG_LAST?> <?=$config['umq']?> <?=LANG_ANS_TICKETS?></h2>*/
				if ((!$_REQUEST['s']) && ($result['status'] == 'answered')) { $j++; $um[$j]=$result;  }
				if ($result['status'] == $status) { //filter by status
					$i++;
					$results[$i]=$result;
				}
			}
		}
	}

	//work out page title
	if ($s == 'basic') { $pagetitle=LANG_BASIC_SEARCH; }
	elseif ($s == 'advanced') { $pagetitle=LANG_ADVANCED_SEARCH; }
	else { $pagetitle=get_real_status_names($status); }

	/*pagingation*/
	$total=count($results);
	$pages=$total / $per;
	if ($p > $pages) { $p=$pages; }
	$start=($p - 1) * $per;
	$end=$p*$per;

	//get a list of the catagories - save repeating
  $cats_res=mysql_query("SELECT * FROM ticket_categories");
  while ($cats_row=mysql_fetch_array($cats_res)) {
      $cats_rows[$cats_row['ID']] = $cats_row;
  }

if (($config['search_disp']) && (!strstr($_SERVER['PHP_SELF'],'search'))) include_once(INC_DIR.'search_form.php');

?>
<script type="text/javascript">
function checkAll(field)
{
for (i = 0; i < field.length; i++)
	field[i].checked = true ;
}

function uncheckAll(field)
{
for (i = 0; i < field.length; i++)
	field[i].checked = false ;
}
</script>

<h2><?=ucwords($pagetitle)?></h2>
<form action="<?=htmlspecialchars($_SERVER['REQUEST_URI'])?>" method="POST">
<div id="main">
<?php 
if ($results) {
?>
	<table border="0" cellspacing="1" cellpadding="2" class="TableMsg" align="center">
<?php
	echo $table_header;
	$class = 'mainTable'; //for table stripes (default)
	foreach ($results as $key => $result) {
		if (($key > $start) && ($key <= $end)) {
			//case by case vars
			$eval = new Ticket($result);
			$cat_row = $cats_rows[$eval->cat];
			$hide = ($_SESSION['user']['type'] == 'client' && $cat_row['hidden']);
			$cat_row['name'] = $hide ? LANG_IN_PROGRESS : $cat_row['name'];
			$pri_text = $config['pri_text'][$eval->priority];
			$pri_style = $config['pri_style'][$eval->priority];
			$class = ($class == 'mainTableAlt') ? 'mainTable' : 'mainTableAlt';
			
			$output=$table_content;
			$output=str_replace('{class}',$class,$output);
			$output=str_replace('{page}',$page,$output);
			$output=str_replace('{id}',$eval->id,$output);
			$output=str_replace('{checkbox}','<input type="checkbox" name="t['.$eval->id.']">',$output);
			$output=str_replace('{short_time}',$eval->short_time,$output);
			$output=str_replace('{subject}',$eval->subject,$output);
			$output=str_replace('{cat_name}',$cat_row['name'],$output);
			$output=str_replace('{pri_style}',$pri_style,$output);
			$output=str_replace('{pri_text}',$pri_text,$output);
			$output=str_replace('{email}',$eval->email,$output);
			$output=str_replace('{name}',$eval->name,$output);
			$output=str_replace('{unanswered}',$eval->unanswered.has_priv_msg($eval->id),$output);
			echo $output;
		}
	}
	?>
	</table>
	<?php
		/*pagination*/
      @($pages = $total / $_SESSION['view']['per']);
      $pages = (intval($pages) == $pages) ? $pages : intval($pages) + 1;
      if ($pages > 1) {
          for ($x = 1; $x <= $pages; ++$x) {
              if ($x == $_SESSION['view']['p']) {
                  $pgs .= "$x, ";
              } else {
			      		$purl=$_SERVER['PHP_SELF'].'?p='.$x;
			      		$qs=preg_replace('/p=[0-9]/', '', $_SERVER['QUERY_STRING']);
			      		if ($qs != '') { $purl.=(substr($qs, 0, 1) == '&')?$qs:"&amp;$qs"; }
			      		$pgs .= '<a href="'.$purl.'">'.$x.'</a>, ';
              }
          }
      }
      $pgs=substr($pgs, 0, strlen($pgs) - 2);
	?>
	<?=intval($total)?> <?=LANG_TICKETS_FOUND?> <?=$pgs ? '('.LANG_PAGES.': '.$pgs.')': ''?> 
	<input class="inputsubmit2" type="button" onclick="checkAll(this.form)" value="<?=LANG_SELECT_ALL?>"> 
	<input class="inputsubmit2" type="button" onclick="uncheckAll(this.form)" value="<?=LANG_UNSELECT?>">
	<?php 
	} else { echo '<p style="text-align: center;">'.LANG_NO_TICKETS.'</p>'; }
?>
</div>
<?php
	if (($config['umq'] > 0) && ($status == 'open') && (count($um) > 0)) {
	$um_total=count($um);
		?>
		<h2><?=LANG_LAST?> <?=$config['umq']?> <?=LANG_ANS_TICKETS?></h2>
		<table border="0" cellspacing="1" cellpadding="2" class="TableMsg" align="center">
	<?php
	echo $table_header;
	$class = 'mainTable'; //for table stripes (default)
	foreach ($um as $key => $result) {
		if ($key >= $um_total-$config['umq']) {
			//case by case vars
			$eval = new Ticket($result);
			$cat_row = $cats_rows[$eval->cat];
			$hide = ($_SESSION['user']['type'] == 'client' && $cat_row['hidden']);
			$cat_row['name'] = $hide ? LANG_IN_PROGRESS : $cat_row['name'];
			$pri_text = $config['pri_text'][$eval->priority];
			$pri_style = $config['pri_style'][$eval->priority];
			$class = ($class == 'mainTableAlt') ? 'mainTable' : 'mainTableAlt';
			
			$output=$table_content;
			$output=str_replace('{class}',$class,$output);
			$output=str_replace('{page}',$page,$output);
			$output=str_replace('{id}',$eval->id,$output);
			$output=str_replace('{checkbox}','',$output);
			$output=str_replace('{short_time}',$eval->short_time,$output);
			$output=str_replace('{subject}',$eval->subject,$output);
			$output=str_replace('{cat_name}',$cat_row['name'],$output);
			$output=str_replace('{pri_style}',$pri_style,$output);
			$output=str_replace('{pri_text}',$pri_text,$output);
			$output=str_replace('{email}',$eval->email,$output);
			$output=str_replace('{name}',$eval->name,$output);
			$output=str_replace('{unanswered}',$eval->unanswered.has_priv_msg($eval->id),$output);
			echo $output;
		}
	}
	?>
	</table>
<?php
	}
?>
<br>
<div class="buttons">
<?php if ($_SESSION['user']['type'] == 'admin' && $login['ID'] == ADMIN) { ?>
<input type="image" src="<?=$buttons_dir?>delete.gif" name="delete" value="<?=LANG_DELETE?>" title="<?=LANG_TIP_DELETE?>" onClick='if(confirm("<?=LANG_DELETE_CONFIRM?>")) return; else return false;'>
<?php } ?>
<?php
  
  switch ($status) {
      case 'closed':
?>
  <input type="image" src="<?=$buttons_dir?>reopen.gif" name="reopen" value="<?=LANG_REOPEN?>" title="<?=LANG_TIP_REOPEN?>">
  <input type="image" src="<?=$buttons_dir?>view_open.gif" name="view_open" value="<?=LANG_VIEW_OPEN?>" title="<?=LANG_TIP_VIEW_OPEN?>">
  <input type="image" src="<?=$buttons_dir?>view_answered.gif" name="view_answered" value="<?=LANG_VIEW_ANSWERED?>" title="<?=LANG_TIP_VIEW_ANSWERED?>">
  <?php
          break;
      case 'open':
?>
  <input type="image" src="<?=$buttons_dir?>close.gif" name="close" value="<?=LANG_CLOSE?>" title="<?=LANG_TIP_CLOSE?>">
  <input type="image" src="<?=$buttons_dir?>view_answered.gif" name="view_answered" value="<?=LANG_VIEW_ANSWERED?>" title="<?=LANG_TIP_VIEW_ANSWERED?>">
  <input type="image" src="<?=$buttons_dir?>view_closed.gif" name="view_closed" value="<?=LANG_VIEW_CLOSED?>" title="<?=LANG_TIP_VIEW_CLOSED?>">
  <?php
          break;
      case 'answered':
?>
  <input type="image" src="<?=$buttons_dir?>close.gif" name="close" value="<?=LANG_CLOSE?>" title="<?=LANG_TIP_CLOSE?>">
  <input type="image" src="<?=$buttons_dir?>view_open.gif" name="view_open" value="<?=LANG_VIEW_OPEN?>" title="<?=LANG_TIP_VIEW_OPEN?>">
  <input type="image" src="<?=$buttons_dir?>view_closed.gif" name="view_closed" value="<?=LANG_VIEW_CLOSED?>" title="<?=LANG_TIP_VIEW_CLOSED?>">
  <?php
          break;
  }
?>
<input type="image" src="<?=$buttons_dir?>refresh.gif" name="refresh" value="<?=LANG_REFRESH?>" title="<?=LANG_TIP_REFRESH?>">
</div>
</form>
<?php load_buttons(); ?>