<?php
/*
	eTicket, Open Source Support Ticket System
	http://eticket.sourceforge.net/

	Released under the GNU General Public License
*/

/* 

	Do not edit this file
	
	Please see settings.php or use the installer

*/

// Emulate register_globals off
function unregister_GLOBALS()
{
    if (!ini_get('register_globals')) {
        return;
    }

    if (isset($_REQUEST['GLOBALS']) || isset($_FILES['GLOBALS'])) {
        die(); //GLOBALS overwrite attempt detected
    }

    // Variables that shouldn't be unset
    $noUnset = array('GLOBALS',  '_GET',
                     '_POST',    '_COOKIE',
                     '_REQUEST', '_SERVER',
                     '_ENV',     '_FILES',
                     '_SESSION');

    foreach ($GLOBALS as $k => $v) {
        if (is_numeric($k) || !in_array($k, $noUnset)) {
            unset($GLOBALS[$k]);
        }
    }
}

unregister_GLOBALS();

require_once('lang.php'); //we need to include this first
require_once('settings.php'); //include the database details and other settings

//detect which OS we're on and produce the correct slash
if ((isset($_ENV['OS'])) && ($_ENV['OS'] == 'Windows_NT')) { define('SLASH', '\\'); }
else { define('SLASH', '/'); }

/* Core variables */

//vars for product - not really used that much atm
define('VERSION','1.5.5.2');
$product_name='eTicket';
$product_desc='Support Ticket System';
$product_url='http://eticket.sourceforge.net/';
//This is the link to product support
$help_link='<a href="http://sourceforge.net/projects/eticket/" target="_blank">eTicket Help</a>';

//files, directories and table vars
$themes_dir='themes'; //directory of themes
$image_dir='images'; //directory of images in themes
$buttons_dir='buttons'; //directory of button images in themes
$install_script='install'; //directory of installer
$inc_dir='inc'; //directory of includes
$captcha_file='captcha.php'; //CAPTCHA MOD
$header_file='header.php'; //part of the theme
$footer_file='footer.php'; //part of the theme

$db_table_config=$db_table_prefix.'config'; //table for config, ignore for now!
$db_table_tickets='tickets'; //table for tickets, ignore for now!

//defines - must be loaded BEFORE INC files are included
if (substr($inc_dir, -1) != SLASH) { $inc_dir=$inc_dir.SLASH; } //just a quick fix...
define('INC_DIR',$rootpath_dir.$inc_dir); //full path of include directory
define('ADMIN', 1); //used to check if the admins are admins
define('ISINC',TRUE); //used to check if this file has been run

require_once(INC_DIR.'class.ticket.php');

//backwards compatability
define('INCLUDE_DIR',INC_DIR);
if ((!isset($theme)) && (isset($settings['theme']))) { $theme=$settings['theme']; }

//var processing
$themes_dir=add_trailing_slash($themes_dir,SLASH);
$theme_dir=add_trailing_slash($themes_dir.$theme,SLASH);
$image_dir=add_trailing_slash($theme_dir.$image_dir,SLASH);
$buttons_dir=add_trailing_slash($image_dir.$buttons_dir,SLASH);
$install_script=add_trailing_slash($install_script,SLASH);
$site_title=stripslashes($site_title);
$site_header=INC_DIR.$header_file;
$site_footer=INC_DIR.$footer_file;

$PHP_SELF=$_SERVER['PHP_SELF'];

//check the script is installed, or die.
if ($installed != TRUE) { 
	if (file_exists($install_script)) { header('Location: '.$install_script); }
	else { die(); }
}

/* More variables */

//Load the page titles for the pages, also used for the buttons
$titles = array('viewticket'=>LANG_TITLE_VIEWTICKET, 
				'admin_login'=>LANG_TITLE_ADMIN_LOGIN,
				'user_login'=>LANG_TITLE_USER_LOGIN, 
				'main'=>'', 
				'pref'=>LANG_TITLE_PREF, 
				'mail'=>LANG_TITLE_MAIL, 
				'cat'=>LANG_TITLE_CAT, 
				'rep'=>LANG_TITLE_REP, 
				'user_group'=>LANG_TITLE_GROUPS, 
				'banlist'=>LANG_TITLE_BANLIST, 
				'my'=>LANG_TITLE_MY);

//This is the timezone data, used in inc/pref.php
$gmoffset = date('Z') / 3600;
$timezones = array(''=>"Server Time (GMT $gmoffset:00)",
                               -12=>"GMT -12:00 (Eniwetok, Kwajalein)",
                               -11=>"GMT -11:00 (Midway Island, Samoa)",
                               -10=>"GMT -10:00 (Hawaii)",
                               -9=>"GMT -09:00 (Alaska)",
                               -8=>"GMT -08:00 (Pacific Time)",
                               -7=>"GMT -07:00 (Mountain Time)",
                               -6=>"GMT -06:00 (Central Time)",
                               -5=>"GMT -05:00 (Eastern Time)",
                               -4=>"GMT -04:00 (Atlantic Time)",
                               -3=>"GMT -03:00 (Greenland)",
                               -2=>"GMT -02:00 (Mid-Atlantic)",
                               -1=>"GMT -01:00 (Azores)",
                               0=>"GMT (Greenwich Mean Time)",
                               1=>"GMT +01:00 (West Central Africa)",
                               2=>"GMT +02:00 (Jerusalem)",
                               3=>"GMT +03:00 (Baghdad)",
                               4=>"GMT +04:00 (Kabul)",
                               5=>"GMT +05:00 (New Delhi)",
                               6=>"GMT +06:00 (Kathmandu)",
                               7=>"GMT +07:00 (Bangkok)",
                               8=>"GMT +08:00 (Hong Kong)",
                               9=>"GMT +09:00 (Tokyo)",
                               10=>"GMT +10:00 (Sydney)",
                               11=>"GMT +11:00 (Solomon Islands)",
                               12=>"GMT +12:00 (Fiji)",
                               13=>"GMT +13:00 (Nuku'alofa)");

//used far and wide throughout
$gmtime = time() - date('Z');

//check if install script exists
if (file_exists($install_script)) { die('<div align="center"><b>'.LANG_FATAL_ERROR.':</b> '.$install_script.' '.LANG_REMOVE_FOR_SECURITY_REASONS.'</div>'); }

//does include dir exist?
if (!file_exists(INC_DIR)) { die('<b>'.LANG_FATAL_ERROR.':</b>'.LANG_INC_DIR_NOT_EXIST.'<br>'.$help_link); }

//connect to database
if ($db_con = @mysql_connect($db_host, $db_user, $db_pass)) { $db_sel = mysql_select_db($db_name, $db_con); }

//check for errors
if (mysql_error()) { die('<b>'.LANG_FATAL_ERROR.':</b> '.LANG_DB_COULD_NOT_CONNECT.'<br>'.mysql_error().'<br>'.$help_link); }

/* Load config from database and merge settings */
//get configuration from database
$config=@mysql_fetch_array(mysql_query('SELECT * FROM '.$db_table_config));
//merge $settings from settings.php with $config from the database
if (isset($settings)) $config=array_merge($config,$settings);
//if we can't get the root_url from the database config, something is broken!
if (!$config['root_url']) { die('<b>'.LANG_FATAL_ERROR.':</b> '.LANG_COULD_NOT_GET_CONF.'<br>'.mysql_error().'<br>'.$help_link); }
//if the attachment dir isn't writable, we'll just disable attachments by removing the variable
if (!(is_writable($config['attachment_dir'])) && (file_exists($config['attachment_dir']))) { unset($config['accept_attachments']); }

//incase we're missing these settings from the settings.php, defaults are loaded here. DO NOT EDIT.
if (!isset($config['presig'])) { $config['presig'] = "\n\n"; }
if (!isset($config['short_date_format'])) { $config['short_date_format'] = 'd/m/Y'; }
if (!isset($config['answer_subj'])) { $config['answer_subj'] = "[#%ticket] %subject"; }
if (!isset($config['answer_msg'])) { $config['answer_msg'] = "%answer"; }
if (!isset($config['pri'])) { $config['pri']=array(1,2,3); }
if (!isset($config['pri_text'])) { $config['pri_text']=array(LANG_LOW,LANG_NORMAL,LANG_HIGH); }
if (!isset($config['pri_style'])) { $config['pri_style']=array('class="priLow"','class="priNormal"','class="priHigh"'); }
if (!isset($config['default_search_days'])) $config['default_search_days']='30';

//sort the ordering of the priorities
$config['pri_text']=array_combine($config['pri'],$config['pri_text']);
$config['pri_style']=array_combine($config['pri'],$config['pri_style']);

//set attachment dir to ensure it has a trailing slash
$config['attachment_dir']=add_trailing_slash($config['attachment_dir'],SLASH);
//set root_url from database config table
$root_url=$config['root_url'];
//set timezone to server time if not defined
$config['timezone'] = ($config['timezone'] == '') ? date('Z')/3600:$config['timezone'];

//make php3 compatible - don't really think we even need this anymore
if (!$_POST) { $_POST = $HTTP_POST_VARS; }
if (!$_GET) { $_GET = $HTTP_GET_VARS; }
if (!$_REQUEST) {
    foreach ($_POST as $item => $val) {
    	if (!$val) { $_REQUEST[$item] = $_GET[$item]; }
    	else { $_REQUEST[$item] = $_POST[$item]; }
    }
}
if (!$_FILES) { $_FILES = $HTTP_POST_FILES; }

//set the action
if (isset($_GET['a'])) { $a=$_GET['a']; }
//trim posts
trim_post(array('login_user','login_pass','login_email','login_ticket'));

if (!isset($nosession)) { //a hack to fix the session problem where its already been started
 session_start();
}

//fixes the logout, to login bug, and the additional admin pages
if (strstr($_SERVER['PHP_SELF'], 'view')) { $type='client'; }
elseif (isset($_SESSION['user']['type'])) { $type=$_SESSION['user']['type']; }
else { $type=(strstr($_SERVER['PHP_SELF'], 'admin'))?'admin':'client'; }

if ($type == 'admin') {
	$id=$_POST['login_user'] ? $_POST['login_user']: $_SESSION['user']['id'];
	$pass=$_POST['login_pass'] ? md5($_POST['login_pass']):$_SESSION['user']['pass'];
}
else {
	$id=$_POST['login_email'] ? strtolower($_POST['login_email']):$_SESSION['user']['id'];
  $pass=$_POST['login_ticket'] ? $_POST['login_ticket']:$_SESSION['user']['pass'];
}
$login=login($type, $id, $pass);
if ($login) {
	$_SESSION['user']['id']=$id;
	$_SESSION['user']['pass']=$pass;
	$_SESSION['user']['type']=$type;
}
elseif (($_POST) && (!preg_match('/open.php/',$_SERVER['PHP_SELF']))) { $err=LANG_ERROR_LOGIN; }

//determine what page to display for the type of user
if ($_SESSION['user']['type'] == 'admin') { $page='admin.php'; }
else { $page='view.php'; }

//start login session
if ((isset($a)) && ($a == 'logout')) { logout($page); }

if ($_SESSION['view']['qs'] != $_SERVER['QUERY_STRING']) {
	if ((!isset($_REQUEST['a'])) && (preg_match("/$page/",$_SERVER['PHP_SELF']))) { 
		$_SESSION['view']['qs']=$_SERVER['QUERY_STRING'];
	}
}

//XSS fix for logins
if (isset($_GET['e'])) { $e=htmlspecialchars(trim($_GET['e'])); }
if (isset($_GET['t'])) { $t=htmlspecialchars(trim($_GET['t'])); }
if (isset($_GET['em'])) { $em=htmlspecialchars(trim($_GET['em'])); }
if (isset($_GET['tt'])) { $tt=htmlspecialchars(trim($_GET['tt'])); }

//View type
/*if ($_POST['view_answered_x']) {
    $_SESSION['view'] = 'answered';
} elseif ($_POST['view_closed_x']) {
    $_SESSION['view'] = 'closed';
} elseif ($_POST['view_open_x']) {
    $_SESSION['view'] = 'open';
}*/

//get $a correct
  if (!$_REQUEST['a']) {
      if ($_POST['close_x']) {
          $_REQUEST['a'] = 'close';
      } elseif ($_POST['reopen_x']) {
          $_REQUEST['a'] = 'reopen';
      } elseif ($_POST['delete_x']) {
          $_REQUEST['a'] = 'delete';
      }
  }

//used for switching in admin.php and view.php
$a=strtolower($_REQUEST['a']);

?>